{*
 *  LDLITE, a program for viewing *.dat files.
 *  Copyright (C) 1998  Paul J. Gyugyi
 *
 *  Translated to Pascal (Delphi 2) by Anders Isaksson 1998
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ldliteVRh, StdCtrls, ExtCtrls, Menus, Placemnt, StrHlder, RXSplit;

const
  WM_INITDONE       = WM_USER + 400;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    mmFile: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Printpreview1: TMenuItem;
    Printsetup1: TMenuItem;
    Recentfiles1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    mmHelp: TMenuItem;
    mmHelpAbout: TMenuItem;
    OpenDialog1: TOpenDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    mmScale: TMenuItem;
    N111: TMenuItem;
    N121: TMenuItem;
    N141: TMenuItem;
    N181: TMenuItem;
    N1101: TMenuItem;
    N5: TMenuItem;
    N211: TMenuItem;
    N411: TMenuItem;
    N811: TMenuItem;
    mmRedraw: TMenuItem;
    mmOptions: TMenuItem;
    moStopOnStep: TMenuItem;
    mmView: TMenuItem;
    Front1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Back1: TMenuItem;
    Top1: TMenuItem;
    Under1: TMenuItem;
    N3D1: TMenuItem;
    Any1: TMenuItem;
    N6: TMenuItem;
    moCachePrimitives: TMenuItem;
    moCacheParts: TMenuItem;
    Shading1: TMenuItem;
    PaintBox1: TPaintBox;
    Panel2: TPanel;
    Bevel2: TBevel;
    ListBox1: TListBox;
    N7: TMenuItem;
    Scan1: TMenuItem;
    FormStorage1: TFormStorage;
    StrHolder1: TStrHolder;
    Panel3: TPanel;
    Panel4: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    RxSplitter1: TRxSplitter;
    CloseSetList1: TMenuItem;
    N8: TMenuItem;
    SaveasBlockCADpart1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure N111Click(Sender: TObject);
    procedure mmRedrawClick(Sender: TObject);
    procedure moStopOnStepClick(Sender: TObject);
    procedure Front1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure Back1Click(Sender: TObject);
    procedure Top1Click(Sender: TObject);
    procedure Under1Click(Sender: TObject);
    procedure N3D1Click(Sender: TObject);
    procedure Any1Click(Sender: TObject);
    procedure mmHelpAboutClick(Sender: TObject);
    procedure moCachePrimitivesClick(Sender: TObject);
    procedure moCachePartsClick(Sender: TObject);
    procedure Shading1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Scan1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1Change(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CloseSetList1Click(Sender: TObject);
    procedure SaveasBlockCADpart1Click(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private declarations }
    file_being_parsed: integer;
    Scale: double;
    FileName: string;
    RotX, RotY, RotZ: double;
    TotTime: longint;
    Dict: TStringList;
    DictU: TStringList;
    SetList: TStringList;
    Dragging: Boolean;
    procedure DoSearch;
    procedure RemoveAllViewChecks;
    procedure WMInitDone(var Message: TMessage); message WM_INITDONE;
    procedure WMCopyData(var Message: TMessage); message WM_COPYDATA;
    procedure CustomSort(s: TStringList);
    procedure LoadSetFromFile(Name: string);
    function CountStuds(Ldd, FileName: string): integer;
    function LastText(s: string): string;
    function HasStud(s: string): boolean;
  public
    { Public declarations }
  end;

var
  Form1             : TForm1;

procedure platform_zDraw(var zp: ZIMAGE; zDC: Pointer);
procedure platform_step(step, level, pause: integer; var zp: ZIMAGE);
procedure platform_comment(comment_string: string; level: integer);

implementation

{$R *.DFM}

uses
  ClipBrd, IniFiles, FileCtrl,
  stub, ldliteVr_main, Debug, SetRot, ytab, UniDIB, About
  ;

var
  redraw_needed     : integer = 0;
  AppDir            : string;
  Views             : TStringList;

  //  hbm:            TBitMap = nil;
  //  uni:            TUniDIB = nil;

type
  TCopyRecord = record
    X, Y: integer;
    s: packed array[0..255] of char;
  end;
  PCopyRecord = ^TCopyRecord;
var
  cs, rs            : TCopyDataStruct;

  CopyRecord,
    RecRecord       : TCopyRecord;


procedure TForm1.WMCopyData(var Message: TMessage);
begin
  rs := PCopyDataStruct(Message.lParam)^;
  case rs.dwData of
    0: begin                            { do you accept? }
        Message.Result := 1;
      end;
    1: begin                            { string message }
        RecRecord := PCopyRecord(rs.lpdata)^;
        ShowMessage(Format('X = %d, Y = %d, s = %s', [RecRecord.x, RecRecord.y, RecRecord.s]));
        Message.Result := 1;
      end;
  end;
end;

procedure TForm1.WMInitDone(var Message: TMessage);
var
  Ini               : TIniFile;
  i                 : integer;
begin
  Ini := TIniFile.Create(FormStorage1.IniFileName);
  Ini.ReadSection('Views', ComboBox1.Items);
  Views.Clear;
  for i := 0 to Pred(ComboBox1.Items.Count) do begin
    Views.Add(Ini.ReadString('Views', ComboBox1.Items[i], ''));
  end;
  Ini.Free;
  ComboBox1.ItemIndex := ComboBox1.Tag;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  zDraw(Pointer(Form1.PaintBox1.Canvas));
  //  if Assigned(hbm) then begin
  //    Canvas.Draw(0, 0, hbm);
  //  end;
end;

procedure platform_zDraw(var zp: ZIMAGE; zDC: Pointer);
var
  Canvas            : TCanvas;
  i, j              : integer;
  i1, j1, j2        : integer;
  bmi               : TBitMapInfo;
begin
  Canvas := TCanvas(zDC);
  if (GetDeviceCaps(Canvas.Handle, RASTERCAPS) and RC_BITBLT) = 0 then begin
    for i := 0 to Pred(zp.rows) do begin
      for j := 0 to Pred(zp.cols) do begin
        Canvas.Pixels[i, j] := zp.DIB.GetPixel(i, j);
        (*
                Canvas.Pixels[i, j] := RGB(zp.r[i*zp.cols+j],
                                           zp.g[i*zp.cols+j],
                                           zp.b[i*zp.cols+j]);
        *)
      end
    end
  end
  else begin
    (*
        if Assigned(hbm) then begin
          Canvas.Draw(0, 0, hbm);
        end;
    *)
    (*
        if Assigned(uni) then begin
          uni.DIBToScreen(Form1.Canvas.Handle)
        end;
    *)
    if (redraw_needed >= 0) then begin
      //      Screen.Cursor := crHourGlass;
            (*
                  if (Assigned(hbm) and (redraw_needed = 2)) then begin
                    hbm.Free;
                    hbm := nil;
                  end;
            *)
            (**
                  if (Assigned(uni) and (redraw_needed = 2)) then begin
                    uni.Free;
                    uni := nil;
                  end;
            **)
            (*
                  if not Assigned(hbm) then begin
                    hbm := TBitMap.Create;
                    hbm.Width := zp.Rows;
                    hbm.Height := zp.Cols;
                    hbm.Canvas.Brush.Color := clGray;
                    hbm.Canvas.FillRect(hbm.Canvas.ClipRect);
            *)
            (**
                  if not Assigned(uni) then begin
                    uni := TUniDIB.Create(zp.Rows, zp.Cols, 24, SBU_NONE);
                    zp.dirty_x1 := 0;
                    zp.dirty_x2 := zp.rows - 1;
                    zp.dirty_y1 := 0;
                    zp.dirty_y2 := zp.cols - 1;
                  end;
            //      Debug.Print(Format('X: %d %d   Y: %d %d  %d %d',
            //          [zp.dirty_x1, zp.dirty_x2, zp.dirty_y1, zp.dirty_y2, zp.rows, zp.cols]));

                  for i := zp.dirty_x1 to Pred(zp.dirty_x2) do begin
                    j1 := zp.Cols - 1;
                    i1 := i * zp.cols;
                    for j := zp.dirty_y1 to Pred(zp.dirty_y2) do begin
                      j2 := i1+j;
            //          hbm.Canvas.Pixels[i, j] := RGB(zp.r[i*zp.cols+j],
                      uni.SetPixel(i, j1 - j, (zp.r[j2] shl 16) or
                                              (zp.g[j2] shl 8) or
                                              (zp.b[j2] shl 0));
                    end;
                  end;
            **)
      zp.dirty_x1 := zp.rows - 1;
      zp.dirty_x2 := 0;
      zp.dirty_y1 := zp.cols - 1;
      zp.dirty_y2 := 0;

      zp.DIB.DIBToScreen(Form1.PaintBox1.Canvas.Handle);
      //      uni.DIBToScreen(Form1.Canvas.Handle);
      //      Canvas.Draw(0, 0, hbm);
      redraw_needed := 0;
      //      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure platform_step(step, level, pause: integer; var zp: ZIMAGE);
begin
  with Form1 do begin
    //    Debug.Print(Format('step %d %d %d', [step, level, pause]));
    //    Screen.Cursor := crDefault;
    redraw_needed := 1;
    //    Form1.FormPaint(nil);
    //    Screen.Cursor := crHourGlass;
  end
end;

procedure platform_comment(comment_string: string; level: integer);
begin
  //  Application.ProcessMessages;
end;

procedure TForm1.CustomSort(s: TStringList);
var
  i                 : integer;
  t                 : TStringList;
  p                 : integer;
begin
  t := TStringList.Create;
  try
    for i := Pred(s.Count) downto 0 do begin
      p := Pos('~', s[i]);
      if p = 0 then
        p := Pos('_', s[i]);
      if p > 0 then begin
        t.Add(s[i]);
        s.Delete(i);
      end
    end;
    s.AddStrings(t);
  finally
    t.Free;
  end
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i                 : integer;
begin
  SetList := TStringList.Create;
  SetList.Sorted := True;
  SetList.Duplicates := dupIgnore;
  ControlStyle := ControlStyle + [csOpaque];
  file_being_parsed := 0;
  Scale := 1.0;
  N3D1Click(nil);

  with TIniFile.Create('ldraw.ini') do try
    LdrawDir := ReadString('ldraw', 'basedirectory', '');
  finally
    Free;
  end;

  if not DirectoryExists(LdrawDir) then begin
    i := 300;
    SetLength(LDrawDir, i);
    i := GetEnvironmentVariable(PChar('LDRAWDIR'), PChar(LDrawDir), i - 1);
    SetLength(LDrawDir, i);
  end;

  Dict := TStringList.Create;
  if FileExists(AppDir + '\ldrawlist.txt') then begin
    Dict.LoadFromFile(AppDir + '\ldrawlist.txt');
    CustomSort(Dict);
    ListBox1.Items.Assign(Dict);
  end
  else begin
    ListBox1.Items.Add('');
    ListBox1.Items.Add(' No LDRAWLIST.TXT file found. Press SCAN to generate it');
  end;
  DictU := TStringList.Create;
  DictU.Assign(Dict);
  for i := 0 to Pred(DictU.Count) do
    DictU[i] := UpperCase(DictU[i]);
  PostMessage(Handle, WM_INITDONE, 0, 0);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  zFree();
  Dict.Free;
  DictU.Free;
  SetList.Free;
end;

procedure TForm1.LoadSetFromFile(Name: string);
var
  i, p, cnt, j      : integer;
  b, s              : string;
begin
  SetList.Clear;
  ListBox1.Items.Clear;
  SetList.Sorted := False;
  SetList.LoadFromFile(Name);
  for i := 0 to Pred(SetList.Count) do begin
    s := SetList[i];
    p := Pos(#9, s);
    if p = 0 then
      p := Pos(' ', s);
    cnt := StrToInt(Copy(s, 1, p - 1));
    SetList[i] := Copy(s, p + 1, 255);
    SetList.Objects[i] := Pointer(cnt);
  end;
  SetList.Sorted := True;
  for i := 0 to Pred(Dict.Count) do begin
    s := Dict[i];
    p := Pos('.', s);
    b := Copy(s, 1, p - 1);
    j := SetList.IndexOf(b);
    if j >= 0 then begin
      ListBox1.Items.Add(IntToStr(integer(SetList.Objects[j])) + #9 + s);
    end
  end
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    Open1.Enabled := False;
    try
      if Pos('.set', LowerCase(OpenDialog1.FileName)) > 0 then begin
        LoadSetFromFile(OpenDialog1.FileName);
      end
      else begin
        FileName := OpenDialog1.FileName;
        mmRedrawCLick(nil);
      end;
    finally
      Open1.Enabled := True;
      mmRedraw.Enabled := True;
      Invalidate;
    end
  end
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.N111Click(Sender: TObject);
var
  i                 : integer;
begin
  for i := 0 to Pred(mmScale.Count) do
    if (mmScale.Items[i].GroupIndex = 2) then
      mmScale.Items[i].Checked := False;

  with (Sender as TMenuItem) do begin
    if (tag < 0) then begin
      Scale := -Tag;
    end
    else if (Tag > 0) then begin
      Scale := 1.0 / Tag;
    end;
    Checked := True;
    StrHolder1.Strings[0] := IntToStr(Round(Scale * 1000.0));
  end;
  mmRedrawCLick(nil);
end;

const
  AlreadyDrawing    : Boolean = False;

procedure TForm1.mmRedrawClick(Sender: TObject);
var
  start, finish     : integer;
  elapsed_time      : double;
  rc                : integer;
  mp                : PMatrix3D;
  vp                : PVector3D;

  function ScanMatrix(s: string): PMatrix3D;
  var
    l               : TStringList;
  begin
    l := TStringList.Create;
    l.CommaText := s;
    if l.Count >= 9 then begin
      Result := SetMatrix(StrToFloat(l[0]), StrToFloat(l[1]), StrToFloat(l[2]),
        StrToFloat(l[3]), StrToFloat(l[4]), StrToFloat(l[5]),
        StrToFloat(l[6]), StrToFloat(l[7]), StrToFloat(l[8]));
    end
    else begin
      Result := nil;
    end;
    l.Free;
  end;

begin
  if AlreadyDrawing then
    Exit;

  AlreadyDrawing := True;
  try
    if StrHolder1.Strings.Count > 0 then
      Scale := StrToInt(StrHolder1.Strings[0]) / 1000.0;
    if Length(FileName) = 0 then Exit;
    elapsed_time := 0.0;
    start := GetTickCount;
    // determine window size
    rc := zReset(PaintBox1.Width, PaintBox1.Height);
    if (rc <> 0) then begin
      Application.MessageBox('Out of Memory, exiting', 'Fatal Error', MB_OK);
      Close;
      Exit;
    end;
    redraw_needed := 2;
    //    Screen.Cursor := crHourGlass;
    Enabled := False;
    try
      //      mmFile.Enabled := False;
      //      mmScale.Enabled := False;
      //      mmRedraw.Enabled := False;
      //      mmView.Enabled := False;
      file_being_parsed := 1;
      if (ComboBox1.ItemIndex >= 0) and (Views.Count > ComboBox1.ItemIndex) then begin
        mp := ScanMatrix(Views[ComboBox1.ItemIndex]);
        if mp <> nil then
          vp := SetTransl(zGetRowsize() / 2, zGetColsize() / 2, 0.0)
        else
          vp := nil;
      end
      else begin
        vp := nil;
        mp := nil;
      end;
      ldlite_parse(FileName, Scale, RotX, RotY, RotZ, vp, mp);
    finally
      Enabled := True;
      Redraw_Needed := 1;
      FormPaint(nil);
      //      mmFile.Enabled := True;
      //      mmScale.Enabled := True;
      //      mmRedraw.Enabled := True;
      //      mmView.Enabled := True;
      file_being_parsed := 0;
      Screen.Cursor := crDefault;
      finish := GetTickCount;
      TotTime := Finish - Start;
      elapsed_time := (finish - start) * 0.001;
      redraw_needed := 1;
    end;
  finally
    AlreadyDrawing := False;
  end
end;

procedure TForm1.RemoveAllViewChecks;
var
  i                 : integer;
begin
  for i := 0 to Pred(mmView.Count) do
    if (mmView.Items[i].GroupIndex = 1) then
      mmView.Items[i].Checked := False;
end;

procedure TForm1.Front1Click(Sender: TObject);
begin
  RemoveAllViewChecks;
  RotX := 0;
  RotY := 0;
  RotZ := 0;
  Front1.Checked := True;
  ComboBox1.ItemIndex := -1;
  mmRedrawCLick(nil);
end;

procedure TForm1.Left1Click(Sender: TObject);
begin
  RemoveAllViewChecks;
  RotX := 0;
  RotY := 90 * pi / 180;
  RotZ := 0;
  Left1.Checked := True;
  ComboBox1.ItemIndex := -1;
  mmRedrawCLick(nil);
end;

procedure TForm1.Right1Click(Sender: TObject);
begin
  RemoveAllViewChecks;
  RotX := 0;
  RotY := -90 * pi / 180;
  RotZ := 0;
  Right1.Checked := True;
  ComboBox1.ItemIndex := -1;
  mmRedrawCLick(nil);
end;

procedure TForm1.Back1Click(Sender: TObject);
begin
  RemoveAllViewChecks;
  RotX := 0;
  RotY := -180 * pi / 180;
  RotZ := 0;
  Back1.Checked := True;
  ComboBox1.ItemIndex := -1;
  mmRedrawCLick(nil);
end;

procedure TForm1.Top1Click(Sender: TObject);
begin
  RemoveAllViewChecks;
  RotX := -90 * pi / 180;
  RotY := 0;
  RotZ := -90 * pi / 180;
  Top1.Checked := True;
  ComboBox1.ItemIndex := -1;
  mmRedrawCLick(nil);
end;

procedure TForm1.Under1Click(Sender: TObject);
begin
  RemoveAllViewChecks;
  RotX := 90 * pi / 180;
  RotY := 0;
  RotZ := 90 * pi / 180;
  Under1.Checked := True;
  ComboBox1.ItemIndex := -1;
  mmRedrawCLick(nil);
end;

procedure TForm1.N3D1Click(Sender: TObject);
begin
  RemoveAllViewChecks;
  RotX := -45 * pi / 180;
  RotY := 35 * pi / 180;
  RotZ := -30 * pi / 180;
  N3D1.Checked := True;
  ComboBox1.ItemIndex := -1;
  mmRedrawCLick(nil);
end;

procedure TForm1.Any1Click(Sender: TObject);
begin
  Rotation.X := -RotX;
  Rotation.Y := RotY;
  Rotation.Z := -RotZ;
  if (Rotation.ShowModal = mrOK) then begin
    RemoveAllViewChecks;
    RotX := -Rotation.X;
    RotY := Rotation.Y;
    RotZ := -Rotation.Z;
    Any1.Checked := True;
  end;
  ComboBox1.ItemIndex := -1;
  mmRedrawCLick(nil);
end;

procedure TForm1.moStopOnStepClick(Sender: TObject);
begin
  moStopOnStep.Checked := not moStopOnStep.Checked;
end;

procedure TForm1.moCachePrimitivesClick(Sender: TObject);
begin
  moCachePrimitives.Checked := not moCachePrimitives.Checked;
  ytab.CachePrimitives := moCachePrimitives.Checked;
end;

procedure TForm1.moCachePartsClick(Sender: TObject);
begin
  moCacheParts.Checked := not moCacheParts.Checked;
  ytab.CacheParts := moCacheParts.Checked;
end;

procedure TForm1.mmHelpAboutClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.Shading1Click(Sender: TObject);
begin
  Shading1.Checked := not Shading1.Checked;
  zShading := Shading1.Checked;
end;

const
  Default8087CW     : Word = $1332 { $133F};
  CWSingle          : Word = ($1332 and $FCFF);
  CWDouble          : Word = ($1332 and $FCFF) or $0200;
  CWExtend          : Word = ($1332 or $0300);

procedure Set8087Single;
asm
        FNINIT
        FWAIT
        FLDCW   CWSingle
end;

procedure Set8087Double;
asm
        FNINIT
        FWAIT
        FLDCW   CWDouble
end;

procedure Set8087Extend;
asm
        FNINIT
        FWAIT
        FLDCW   CWExtend
end;

procedure TForm1.FormResize(Sender: TObject);
var
  l, t, h, w        : integer;
begin
  redraw_needed := 1;
  t := Panel2.Top;
  L := Panel2.Left + Panel2.Width + 1;
  W := ClientWidth - Panel2.Width - 1;
  W := W - (W mod 4);
  H := ClientHeight - Panel3.Height - Panel4.Height - 1;
  H := H - (H mod 4);
  Bevel2.SetBounds(L, T, W, H);
  PaintBox1.SetBounds(L + 2, T + 2, W - 4, H - 4);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  DoSearch;
end;

procedure TForm1.DoSearch;
var
  i                 : integer;
  j                 : integer;
  s                 : string;
  c                 : TStringList;
  Cnt               : integer;
  Match             : Boolean;
begin
  ListBox1.Items.BeginUpdate;
  try
    ListBox1.Clear;
    s := UpperCase(Edit1.Text);
    c := TStringList.Create;
    if (Length(s) > 0) and (s[1] = '"') then begin
      if s[Length(s)] <> '"' then
        c.CommaText := s + '"'
      else
        c.CommaText := s;
    end
    else begin
      c.CommaText := s;
    end;
    Cnt := 0;
    if (Length(s) = 0) then begin
      for i := 0 to Pred(Dict.Count) do begin
        ListBox1.Items.Add(Dict[i]);
        Inc(Cnt);
      end
    end
    else begin
      for i := 0 to Pred(Dict.Count) do begin
        Match := True;
        for j := 0 to Pred(c.Count) do begin
          Match := Match and (Pos(c[j], DictU[i]) > 0);
        end;
        if Match then begin
          ListBox1.Items.Add(Dict[i]);
          Inc(Cnt);
        end
      end
    end;
  finally
    c.Free;
    ListBox1.Items.EndUpdate;
    //    Label2.Caption := Format('%d matches found', [Cnt]);
  end
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  f1                : string;
  i                 : integer;
begin
  StartNewPiece;
  if (ListBox1.ItemIndex >= 0) and (AlreadyDrawing = False) then begin
    f1 := ListBox1.Items[ListBox1.ItemIndex];
    Panel3.Caption := f1;
    //    Application.ProcessMessages;
    i := Pos(#9, f1);
    if SetList.Count > 0 then begin
      f1 := Copy(f1, i + 1, 255);
      i := Pos(#9, f1);
    end;
    if (i > 0) then begin
      FileName := LDrawDir + '\PARTS\' + Copy(f1, 1, i - 1);
      mmRedrawCLick(nil);
    end
  end
end;

function TForm1.LastText(s: string): string;
var
  p                 : integer;
begin
  p := Length(s);
  while (p > 0) and not (s[p] in [#9, ' ']) do
    Dec(p);
  Result := Copy(s, p + 1, MaxInt);
end;

function TForm1.HasStud(s: string): boolean;
var
  p                 : integer;
begin
  Result := False;
  p := Pos('STUD', s);
  if p > 0 then begin
    Inc(p, 4);
    case s[p] of
      '.': begin
          Result := True;
        end;
      '2': begin
          Inc(p);
          case s[p] of
            '.': begin
                Result := True;
              end;
            'A': begin
                Inc(p);
                case s[p] of
                  '.': Result := True;
                end;
              end;
          end;
        end;
      '6': begin
          Inc(p);
          case s[p] of
            '.': Result := True;
          end;
        end;
      '7': begin
          Inc(p);
          case s[p] of
            '.': Result := True;
          end;
        end;
      'E': begin
          Inc(p);
          case s[p] of
            'L': begin
                Inc(p);
                case s[p] of
                  '.': Result := True;
                end;
              end;
          end;
        end;
    end
  end
end;

function TForm1.CountStuds(Ldd, FileName: string): integer;
var
  D                 : TextFile;
  Line              : string;
  ul                : string;
  j                 : integer;
  NextFile          : string;
begin
  AssignFile(D, Ldd + '\' + FileName);
  Result := 0;
  try
    Reset(D);
    while not Eof(D) do begin
      Readln(D, Line);
      Line := Trim(Line);
      if (Length(Line) > 1) then begin
        if (Line[1] = '1') then begin
          ul := UpperCase(Line);
          if HasStud(ul) then begin
            Inc(Result);
          end
          else begin
            // Including subpart with studs?
            NextFile := LastText(ul);
            Result := Result + CountStuds(Ldd, NextFile);
          end
        end
      end
    end;
    CloseFile(D);
  except
    ;
  end;
end;

procedure TForm1.Scan1Click(Sender: TObject);
var
  i, i1, j          : integer;
  s                 : string;
  Line              : string;
  ul                : string;
  Ldd               : string;
  f                 : TSearchRec;
  t                 : TStringList;
  StudCount         : integer;
  NextFile          : string;
begin
  Ldd := LdrawDir;
  if (Length(Ldd) > 0) and (Ldd[Length(Ldd)] = '\') then
    Delete(Ldd, Length(Ldd), 1);
  Ldd := Ldd + '\PARTS';
  t := TStringList.Create;
  Screen.Cursor := crHourGlass;
  try
    i := FindFirst(ldd + '\*.dat', faAnyFile, f);
    try
      while (i = 0) do begin
        with TStringList.Create do try
          LoadFromFile(ldd + '\' + f.Name);
          StudCount := 0;
          Line := Strings[0];
          if (Pos('~MOVED', UpperCase(Line)) = 0) then begin
            s := Copy(Line, 2, 255);
            for i1 := 1 to Pred(Count) do begin
              Line := Trim(Strings[i1]);
              if (Length(Line) > 1) then begin
                if (Line[1] = '0') then begin
                  ul := UpperCase(Line);
                  j := Pos('CATEGORY', ul);
                  if j = 0 then
                    j := Pos('KEYWORDS', ul);
                  if (j > 0) then begin
                    s := s + ' ' + Copy(Line, j, 255);
                  end
                end
                else if (Line[1] = '1') then begin
                  ul := UpperCase(Line);
                  if HasStud(ul) then begin
                    Inc(StudCount);
                  end
                  else begin
                    // Including subpart with studs?
                    NextFile := LastText(ul);
                    StudCount := StudCount + CountStuds(Ldd, NextFile);
                  end
                end
              end
            end;
            t.Add(s + #9 + f.Name + #9 + Format('|%d|', [StudCount]));
          end;
        finally
          Free;
        end;
        i := FindNext(f);
      end;
    finally
      FindClose(f);
      t.Sort;
      CustomSort(t);
      for i := 0 to Pred(t.Count) do begin
        j := Pos(#9, t[i]);
        t[i] := Copy(t[i], j + 1, 255) + #9 + Copy(t[i], 1, j - 1);
      end;
      t.SaveToFile(AppDir + '\ldrawlist.txt');
      ListBox1.Items.Assign(t);
      Dict.Assign(t);
      DictU.Assign(t);
      for i := 0 to Pred(DictU.Count) do
        DictU[i] := UpperCase(DictU[i]);
    end;
  finally
    Screen.Cursor := crDefault;
    t.Free;
  end
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_return then begin
    ListBox1.SetFocus;
    ListBox1.ItemIndex := 0;
    ListBox1Click(nil);
  end
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_return then
    Edit1.SetFocus
  else if ListBox1.ItemIndex >= 0 then begin
    if (ssCtrl in Shift) and (Key = Ord('C')) then begin
      ClipBoard.AsText := ListBox1.Items[ListBox1.ItemIndex];
    end
  end
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  ComboBox1.Tag := ComboBox1.ItemIndex;
  mmRedrawCLick(nil);
end;

procedure TForm1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SetCapture(ListBox1.Handle);
  ListBox1Click(Sender);
  Screen.Cursor := crDrag;
end;

var
  RecHnd            : THandle;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  p                 : TPoint;
  s                 : string;
  b                 : string;
  i                 : integer;
  cnt               : integer;
begin
  Screen.Cursor := crDefault;
  ReleaseCapture;
  p := ListBox1.ClientToScreen(Point(X, Y));
  //  ShowMessage(Format('x = %d, y = %d', [p.x, p.y]));
  RecHnd := WindowFromPoint(p);
  //  ShowMessage('hWnd = ' + IntToStr(h));
  CopyRecord.X := p.X;
  CopyRecord.Y := p.Y;
  s := ListBox1.Items[ListBox1.ItemIndex];
  if Dragging and (SetList.Count > 0) then begin
    i := Pos(#9, s);
    s := Copy(s, i + 1, 255);
    i := Pos('.', s);
    b := Copy(s, 1, i - 1);
    i := SetList.IndexOf(b);
    cnt := integer(SetList.Objects[i]) - 1;
    SetList.Objects[i] := Pointer(cnt);
    if cnt > 0 then
      ListBox1.Items[ListBox1.ItemIndex] := Format('%d%s%s', [cnt, #9, s])
    else
      ListBox1.Items.Delete(ListBox1.ItemIndex);
  end;
  StrPLCopy(CopyRecord.s, s, SizeOf(CopyRecord.s));
  cs.dwData := 1;
  cs.cbData := SizeOf(CopyRecord);
  cs.lpData := @CopyRecord;
  SendMessage(RecHnd, WM_COPYDATA, Handle, longint(@cs));
  RecHnd := THandle(-1);
end;

procedure TForm1.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  p                 : TPoint;
  h                 : THandle;
begin
  if (Shift * [ssLeft, ssRight, ssMiddle, ssDouble]) = [ssLeft] then begin
    p := ListBox1.ClientToScreen(Point(X, Y));
    h := WindowFromPoint(p);
    if h <> RecHnd then begin
      RecHnd := h;
      cs.dwData := 0;
      cs.cbData := 0;
      cs.lpData := nil;
      if SendMessage(RecHnd, WM_COPYDATA, Handle, longint(@cs)) > 0 then begin
        Screen.Cursor := crDrag;
        Dragging := True;
      end
      else begin
        Screen.Cursor := crNoDrop;
        Dragging := False;
      end
    end
  end;
end;

procedure TForm1.CloseSetList1Click(Sender: TObject);
begin
  SetList.Clear;
  Listbox1.Items.Assign(Dict);
end;

procedure TForm1.SaveasBlockCADpart1Click(Sender: TObject);
begin
  SaveAsBlockCAD(ExtractFileName(FileName));
end;

procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  p                 : integer;
  s                 : string;
  s1, s2, s3        : string;
begin
  with Control as TListBox, Canvas do begin
    FillRect(Rect);
    s := Items[Index];
    p := Pos(#9, s);
    if p > 0 then begin
      s1 := Copy(s, 1, p - 1);
      s := Copy(s, p + 1, MaxInt);
      p := Pos(#9, s);
      if p > 0 then begin
        s2 := Copy(s, 1, p - 1);
        s3 := Copy(s, p + 1, MaxInt);
      end
      else begin
        s2 := s;
        s3 := '';
      end
    end
    else begin
      s1 := s;
      s2 := '';
      s3 := '';
    end;
    Font.Color := clGreen;
    TextOut(Rect.Left + 0, Rect.Top, s1);
    //    TextOut(Rect.Left + 70, Rect.Top, s2);
    Font.Color := clBlue;
    TextOut(Rect.Left + 90, Rect.Top, s3);
  end
end;

initialization
  DecimalSeparator := '.';
  Set8087Single;
  AppDir := ExtractFilePath(Application.ExeName);
  Views := TStringList.Create;
finalization
  Views.Free;
  Set8087Extend;
end.

